using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace classesandmembers
{
	class ToDoItem
	{
		//fields
		string item = "";
		string description = "";
      
		//properties
		public string Item
		{
			get
			{
				return item;
			}
		}
      
		public string Description
		{
			get
			{
				return description;
			}
		}

		//methods      
		public void SetInfo(
			string item, string description)
		{
			this.item = item;
			this.description = description;
		}
	}
   
	class ToDoList
	{
		//fields
		Hashtable list = new Hashtable();
      
		//methods      
		public void Add(ToDoItem tditem)
		{
			list.Add(tditem.Item,
				tditem.Description);
		}
      
		public void Remove(ToDoItem tditem)
		{
			list.Remove(tditem.Item);
		}

		public ICollection TaskList
		{
			get
			{
				return list.Values;
			}
		}

	}

	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.HyperLink hypViewList;
		protected System.Web.UI.WebControls.TextBox txtItem;
		protected System.Web.UI.WebControls.Label lblToDo;
		protected System.Web.UI.WebControls.TextBox txtDescription;
		protected System.Web.UI.WebControls.Label lblItem;
		protected System.Web.UI.WebControls.Label lblDescription;
		protected System.Web.UI.WebControls.Label lblHelp;
		protected System.Web.UI.WebControls.Button btnTask;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnTask.Click += new System.EventHandler(this.btnTask_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		//ClearFields simply does
		//what the name implies
		//it resets the textboxes in
		//the form. We call this function
		//after adding a task to the list.
		void ClearFields()
		{
			txtItem.Text = "";
			txtDescription.Text = "";
		}

		private void btnTask_Click(object sender, System.EventArgs e)
		{
			ToDoItem item = new ToDoItem();
			item.SetInfo(txtItem.Text, 
				txtDescription.Text);

			//Retrieve the ToDoList from the
			//global Application object, and add
			//the newly created ToDoItem to the
			//list. Then clear the form fields.
			//Because many clients may be
			//accessing the same list
			//simultaneously make sure the code is
			//thread-safe with Lock and Unlock.
			Application.Lock();
			ToDoList list =
				(ToDoList)Application["list"];
			list.Add(item);
			Application.UnLock();
			ClearFields();
		}
	}
}
